REM  *****  BASIC  *****
Global const subtranslatedirectory = "/.libreofficetranslate"
Global const basicPath = ""

Sub Main
rem Main
End Sub


Option Explicit

Function getClipboardText () AS String
dim oClip as object ,oConverter as object
dim oClipContents as object ,oTypes as object
dim i%
oClip = createUnoService("com.sun.star.datatransfer.clipboard.SystemClipboard")
oConverter = createUnoService("com.sun.star.script.Converter")
On Error Resume Next
oClipContents = oClip.getContents
oTypes = oClipContents.getTransferDataFlavors
For i=LBound(oTypes) To UBound(oTypes)
  If oTypes(i).MimeType = "text/plain;charset=utf-16" Then
    Exit For
  End If
Next
If (i >= 0) Then
  On Error Resume Next
  getClipboardText = oConverter.convertToSimpleType _
                     (oClipContents.getTransferData(oTypes(i)), com.sun.star.uno.TypeClass.STRING)
End If
End Function

sub Copy2Clipboard
dim document   as object
dim dispatcher as object
document   = ThisComponent.CurrentController.Frame
dispatcher = createUnoService("com.sun.star.frame.DispatchHelper")

dispatcher.executeDispatch(document, ".uno:Copy", "", 0, Array())

end sub

Function getlang(filename As String, defaultlang As String)
	Dim aFile As String
	Dim iNumber As Integer
	Dim sLine As String
	sLine=""
	if basicPath="" then
		aFile = curdir & subtranslatedirectory & "/" & filename
	else
		aFile = basicPath & subtranslatedirectory & "/" & filename
	end if
	If NOT FileExists( aFile ) then 
		sLine=defaultlang
	Else 
		iNumber = Freefile
		Open aFile For Input As #iNumber
		if not eof(#iNumber) Then
			Line Input #iNumber, sLine
		EndIf
		Close #iNumber
		if sLine="" then
			sLine=defaultlang
		end if
	End If
	getlang=Trim(sLine)
End Function

Function gettranslation(filename As String)
	Dim aFile As String
	Dim iNumber As Integer
	Dim sLine As String
	Dim sRes As String
	Dim defaultlang As String
	defaultlang = "" ' Lisättyä purkkaa
	sLine=""
	sRes=""
	aFile = curdir & subtranslatedirectory & "/" & filename
	
	if basicPath="" then
		aFile = curdir & subtranslatedirectory & "/" & filename
	else
		aFile = basicPath & subtranslatedirectory & "/" & filename
	end if

	
	If NOT FileExists( aFile ) then 
		sLine="error" 'defaultlang
		MsgBox ("Ei löydy tiedostoa:" & aFile)
	Else 
		iNumber = Freefile
		Open aFile For Input As #iNumber
		while not eof(#iNumber) 
			Line Input #iNumber, sLine
			sRes = sRes & sLine
		WEnd
		Close #iNumber
		if sLine="" then
			sLine="error2" ' defaultlang
		end if
	End If
	gettranslation=Trim(sRes)
End Function

Sub setNeededFiles()
	Dim rootPath As String
	Dim lang As STring
	if basicPath="" then
		rootpath = curdir & subtranslatedirectory  
	else
		rootpath = basicPath & subtranslatedirectory 
	end if
	if NOT FileExists(rootpath) then
		mkdir(rootPath)
	End If
	If NOT FileExists( rootPath & "/" & "fromlang.txt") Then
		setLang("fromlang.txt","fi")
	End If
	If NOT FileExists( rootPath & "/" & "tolang.txt") Then
		setLang("tolang.txt","en")
	End If

End Sub


Sub setlang(lang As String, filename As String) 
	Dim aFile As String
	Dim iNumber As Integer
	Dim sLine As String
	aFile = curdir & subtranslatedirectory & filename
	if basicPath="" then
		aFile = curdir & subtranslatedirectory & "/" & filename
	else
		aFile = basicPath & subtranslatedirectory & "/" & filename
	end if
	sLine = Trim( lang)
	iNumber = Freefile
	Open aFile For Output As #iNumber
	Print #iNumber, sLine
	Close #iNumber
End Sub

Function langtoString(langs As String ) As String
	Dim lang(125) As String
	Dim sLang(125) As String
	Dim i As Integer
	
	lang(0)="af"
slang(0)="Afrikaans"
lang(1)="am"
slang(1)="Amharic"
lang(2)="ar"
slang(2)="Arabic"
lang(3)="az"
slang(3)="Azerbaijani"
lang(4)="ba"
slang(4)="Bashkir"
lang(5)="be"
slang(5)="Belarusian"
lang(6)="bg"
slang(6)="Bulgarian"
lang(7)="bn"
slang(7)="Bengali"
lang(8)="bs"
slang(8)="Bosnian"
lang(9)="ca"
slang(9)="Catalan"
lang(10)="ceb"
slang(10)="Cebuano"
lang(11)="co"
slang(11)="Corsican"
lang(12)="cs"
slang(12)="Czech"
lang(13)="cy"
slang(13)="Welsh"
lang(14)="da"
slang(14)="Danish"
lang(15)="de"
slang(15)="German"
lang(16)="el"
slang(16)="Greek"
lang(17)="en"
slang(17)="English"
lang(18)="eo"
slang(18)="Esperanto"
lang(19)="es"
slang(19)="Spanish"
lang(20)="et"
slang(20)="Estonian"
lang(21)="eu"
slang(21)="Basque"
lang(22)="fa"
slang(22)="Persian"
lang(23)="fi"
slang(23)="Finnish"
lang(24)="fj"
slang(24)="Fijian"
lang(25)="fr"
slang(25)="French"
lang(26)="fy"
slang(26)="Frisian"
lang(27)="ga"
slang(27)="Irish"
lang(28)="gd"
slang(28)="Scots Gaelic"
lang(29)="gl"
slang(29)="Galician"
lang(30)="gu"
slang(30)="Gujarati"
lang(31)="ha"
slang(31)="Hausa"
lang(32)="haw"
slang(32)="Hawaiian"
lang(33)="he"
slang(33)="Hebrew"
lang(34)="hi"
slang(34)="Hindi"
lang(35)="hmn"
slang(35)="Hmong"
lang(36)="hr"
slang(36)="Croatian"
lang(37)="ht"
slang(37)="Haitian Creole"
lang(38)="hu"
slang(38)="Hungarian"
lang(39)="hy"
slang(39)="Armenian"
lang(40)="id"
slang(40)="Indonesian"
lang(41)="ig"
slang(41)="Igbo"
lang(42)="is"
slang(42)="Icelandic"
lang(43)="it"
slang(43)="Italian"
lang(44)="ja"
slang(44)="Japanese"
lang(45)="jv"
slang(45)="Javanese"
lang(46)="ka"
slang(46)="Georgian"
lang(47)="kk"
slang(47)="Kazakh"
lang(48)="km"
slang(48)="Khmer"
lang(49)="kn"
slang(49)="Kannada"
lang(50)="ko"
slang(50)="Korean"
lang(51)="ku"
slang(51)="Kurdish"
lang(52)="ky"
slang(52)="Kyrgyz"
lang(53)="la"
slang(53)="Latin"
lang(54)="lb"
slang(54)="Luxembourgish"
lang(55)="lo"
slang(55)="Lao"
lang(56)="lt"
slang(56)="Lithuanian"
lang(57)="lv"
slang(57)="Latvian"
lang(58)="mg"
slang(58)="Malagasy"
lang(59)="mhr"
slang(59)="Eastern Mari"
lang(60)="mi"
slang(60)="Maori"
lang(61)="mk"
slang(61)="Macedonian"
lang(62)="ml"
slang(62)="Malayalam"
lang(63)="mn"
slang(63)="Mongolian"
lang(64)="mr"
slang(64)="Marathi"
lang(65)="mrj"
slang(65)="Hill Mari"
lang(66)="ms"
slang(66)="Malay"
lang(67)="mt"
slang(67)="Maltese"
lang(68)="mww"
slang(68)="Hmong Daw"
lang(69)="my"
slang(69)="Myanmar"
lang(70)="ne"
slang(70)="Nepali"
lang(71)="nl"
slang(71)="Dutch"
lang(72)="no"
slang(72)="Norwegian"
lang(73)="ny"
slang(73)="Chichewa"
lang(74)="otq"
slang(74)="Querétaro Otomi"
lang(75)="pa"
slang(75)="Punjabi"
lang(76)="pap"
slang(76)="Papiamento"
lang(77)="pl"
slang(77)="Polish"
lang(78)="ps"
slang(78)="Pashto"
lang(79)="pt"
slang(79)="Portuguese"
lang(80)="ro"
slang(80)="Romanian"
lang(81)="ru"
slang(81)="Russian"
lang(82)="sd"
slang(82)="Sindhi"
lang(83)="si"
slang(83)="Sinhala"
lang(84)="sk"
slang(84)="Slovak"
lang(85)="sl"
slang(85)="Slovenian"
lang(86)="sm"
slang(86)="Samoan"
lang(87)="sn"
slang(87)="Shona"
lang(88)="so"
slang(88)="Somali"
lang(89)="sq"
slang(89)="Albanian"
lang(90)="sr-Cyrl"
slang(90)="Serbian (Cyrillic)"
lang(91)="sr-Latn"
slang(91)="Serbian (Latin)"
lang(92)="st"
slang(92)="Sesotho"
lang(93)="su"
slang(93)="Sundanese"
lang(94)="sv"
slang(94)="Swedish"
lang(95)="sw"
slang(95)="Swahili"
lang(96)="ta"
slang(96)="Tamil"
lang(97)="te"
slang(97)="Telugu"
lang(98)="tg"
slang(98)="Tajik"
lang(99)="th"
slang(99)="Thai"
lang(100)="tl"
slang(100)="Filipino"
lang(101)="tlh"
slang(101)="Klingon"
lang(102)="tlh-Qaak"
slang(102)="Klingon (pIqaD)"
lang(103)="to"
slang(103)="Tongan"
lang(104)="tr"
slang(104)="Turkish"
lang(105)="tt"
slang(105)="Tatar"
lang(106)="ty"
slang(106)="Tahitian"
lang(107)="udm"
slang(107)="Udmurt"
lang(108)="uk"
slang(108)="Ukrainian"
lang(109)="ur"
slang(109)="Urdu"
lang(110)="uz"
slang(110)="Uzbek"
lang(111)="vi"
slang(111)="Vietnamese"
lang(112)="xh"
slang(112)="Xhosa"
lang(113)="yi"
slang(113)="Yiddish"
lang(114)="yo"
slang(114)="Yoruba"
lang(115)="yua"
slang(115)="Yucatec Maya"
lang(116)="yue"
slang(116)="Cantonese"
lang(117)="zh-CN"
slang(117)="Chinese Simplified"
lang(118)="zh-TW"
slang(118)="Chinese Traditional"
lang(119)="zu"
slang(119)="Zulu"

	
	langtoString="Unknown"
	for i=0 to 124
		If UCASE(lang(i))=UCASE(langs) Then
			langtoString=slang(i)
		End If
		If UCASE(slang(i))=UCASE(langs) Then
			langToString=" " & lang(i)
		end if
	Next i
End Function

Sub ChangeLanguages
	dim fromlang As String
	dim tolang As String
	dim langs(10) As String
	dim slangs As String
	dim i As Integer
	dim s As String
	
	langs(0)="af,am,ar,az,ba,be,bg,bn,bs,ca,ceb,co,cs,cy,da,de,el,en,eo,es"
	langs(1)="et,eu,fa,fi,fj,fr,fy,ga,gd,gl,gu,ha,haw,he,hi,hmn,hr,ht,hu,hy"
	langs(2)="id,ig,is,it,ja,jv,ka,kk,km,kn,ko,ku,ky,la,lb,lo,lt,lv,mg,mhr"
	langs(3)="mi,mk,ml,mn,mr,mrj,ms,mt,mww,my,ne,nl,no,ny,otq,pa,pap,pl,ps,pt"
	langs(4)="ro,ru,sd,si,sk,sl,sm,sn,so,sq,sr-Cyrl,sr-Latn,st,su,sv,sw,ta,te,tg,th"
	langs(5)="tl,tlh,tlh-Qaak,to,tr,tt,ty,udm,uk,ur,uz,vi,xh,yi,yo,yua,yue,zh-CN,zh-TW,zu"
	slangs=""
	for i=0 to 5
		slangs=slangs & langs(i) & chr$(13)
		'msgbox slangs
	next i
	' msgbox (slangs,0,"Kielivaihtoehdot")
	fromlang = Trim(InputBox (slangs,"Valitse käännettävä kieli" ,getLang("fromlang.txt","fi")))
	s=langToString(fromlang)
	if left$(s,1)=" " Then
		fromlang = Trim(s)
	Else
		fromlang = Trim(langToString(Trim(s)))
	End If
	tolang = Trim(InputBox ( slangs,"Valitse käännöksen kieli",getLang("tolang.txt","en")))
	s=langToString(tolang)
	If left$(s,1)=" " Then
		ToLang = Trim(s)
	Else
		ToLang = Trim(langToString(Trim(s)))
	End If
	setLang(fromlang, "fromlang.txt")
	setLang(tolang, "tolang.txt")
	fromlang=getLang("fromlang.txt","fi")
	tolang=getLang("tolang.txt","en")
	MsgBox("uudet kielet:" & fromlang & "->" & tolang & chr$(13) & langToString(fromlang) & "->" & langtoString(tolang))
end Sub

Function TranslateText(sText As String) 
	dim fromlang As String
	dim tolang As String
	dim sShellCommand As String
	dim res As String
	dim notinfloop As Integer
	dim aFile As String
	dim sPath As String
	dim s As String
	res=""
	
	fromlang=getlang("fromlang.txt","fi")
	tolang=getLang("tolang.txt","en")
	
	If basicPath="" Then
		sPath = curdir &  subtranslatedirectory & "/" 
	Else 
		sPath = basicPath & subtranslatedirectory & "/" 
	End If
	
	
	if FileExists(sPath & "translated.txt") Then
		Kill(sPath & "translated.txt")
		While FileExists(sPath & "translated.txt")
			wait 1
		Wend
	End If
	if FileExists(sPath & "translated2.txt") Then
		Kill(sPath & "translated2.txt")
		While  FileExists(sPath & "translated.txt")
			wait 1
		Wend
		
	End If
	wait (300)
	
	setLang(sText,"param.txt") ' Asettaa parametrin shellikäskylle
	notinfloop=0
	
	while ((NOT (FileExists( sPath & "param.txt") )) AND (notinfloop<1000))
		wait 200
		notinfloop=notinfloop+1
	Wend
	wait (500)
	
	s="bash -c 'cat " & sPath & "param.txt" & "|trans -b -from " & fromlang & " -to " & tolang & " >"& sPath & "translated.txt" & "'"
	Shell(s,0,true)
	
	s="bash -c 'cat " & sPath & "param.txt" & "|trans -b -from " & tolang & " -to " & fromlang & " >"& sPath & "translated2.txt" & "'"
	Shell(s,0,true)
	
	
	aFile = curdir & subtranslatedirectory
	if basicPath="" then
		aFile = curdir & subtranslatedirectory & "/" 
	else
		aFile = basicPath & subtranslatedirectory & "/" 
	end if
	
	notinfloop=0
	while ((NOT (FileExists( aFile & "translated2.txt") AND FileExists( aFile & "translated2.txt") )) AND (notinfloop<100))
		wait 200
		notinfloop=notinfloop+1
	Wend
	wait 200

	notinfloop=0
	while (( gettranslation("translated2.txt")="") OR ( gettranslation("translated.txt")="")) AND (notinfloop<5) 
		wait 400
		notinfloop=notinfloop+1
	Wend

	fromlang=getlang("fromlang.txt","fi")
	tolang=getLang("tolang.txt","en")
	
	res ="yes(" & fromlang & ")->" & gettranslation("translated2.txt") 
	res = res & chr$(13) & "no(" & tolang & ")->" & gettranslation("translated.txt")
	res = res & chr$(13)
	res = res & "Cancel -> No Change" 
	TranslateText=res
End Function

Sub appendText(text As String) 
	dim document   as object
	dim dispatcher as object
	document   = ThisComponent.CurrentController.Frame
	dispatcher = createUnoService("com.sun.star.frame.DispatchHelper")
	dim args1(0) as new com.sun.star.beans.PropertyValue
	args1(0).Name = "Text"
	args1(0).Value = text

	dispatcher.executeDispatch(document, ".uno:InsertText", "", 0, args1())
End Sub

Function isclean(text As String) As Boolean
	dim res As Boolean 
	dim i As Integer
	res = true
	for i=1 to len(text)
		if(mid(text,i,1)>" ") Then
			res=false
		End If
	next
	isclean=res
End Function

Sub Translate
	dim sText As String
	dim res As Integer
	dim sTranslated As String
	dim langs(10) As String
	dim slangs As String
	dim i As Integer
	
	langs(0)="af,am,ar,az,ba,be,bg,bn,bs,ca,ceb,co,cs,cy,da,de,el,en,eo,es"
	langs(1)="et,eu,fa,fi,fj,fr,fy,ga,gd,gl,gu,ha,haw,he,hi,hmn,hr,ht,hu,hy"
	langs(2)="id,ig,is,it,ja,jv,ka,kk,km,kn,ko,ku,ky,la,lb,lo,lt,lv,mg,mhr"
	langs(3)="mi,mk,ml,mn,mr,mrj,ms,mt,mww,my,ne,nl,no,ny,otq,pa,pap,pl,ps,pt"
	langs(4)="ro,ru,sd,si,sk,sl,sm,sn,so,sq,sr-Cyrl,sr-Latn,st,su,sv,sw,ta,te,tg,th"
	langs(5)="tl,tlh,tlh-Qaak,to,tr,tt,ty,udm,uk,ur,uz,vi,xh,yi,yo,yua,yue,zh-CN,zh-TW,zu"
	slangs=""
	for i=0 to 5
		slangs=slangs & langs(i) & chr$(13)
		'msgbox slangs
	next i

	Copy2Clipboard()
	sText = Trim(getClipboardText())
	if isclean(sText) Then
		res=MsgBox ("Haluatko määritellä kielet ?" & chr$(13) & slangs, MB_YESNOCANCEL+MB_ICONQUESTION)
		If res=IDYES Then
			ChangeLanguages
		End If
	else 
		res= MsgBox (translateText(sText),  MB_YESNOCANCEL+MB_ICONQUESTION, "Translated")
		If res=IDYES Then
			appendText(gettranslation("translated2.txt"))
		End If
		If res=IDNO Then
			appendText(gettranslation("translated.txt"))
			
		End If
	end if
end Sub


